#include<iostream.h>
#include<stdio.h>
#define N 100000
int l[N],next[N][10],p[N],min[N],sp,st[N],stn,ls;
char s[N];

void gen(int w){
	int j;
	if (w==0){
		s[sp]='a'; sp++; return;
	}
	for(j=0;j<l[w];j++) gen(next[w][(j+p[w])%l[w]]);
	s[sp]='0'+l[w]; sp++;
}

int main(){
	freopen("chandelier.in","rt",stdin);
	freopen("chandelier.out","wt",stdout);
	char c;
	int i,j,k,mn,t,q;
	stn=0; ls=1;
	while(cin >> c){
		if (c=='a') { st[stn]=0; stn++; continue; };
		q=c-'0'; l[ls]=q;
		for(i=0;i<q;i++) next[ls][i]=st[stn-q+i];
		stn-=q;
		st[stn]=ls; stn++;
		ls++;
	}
	min[0]=1;
	for(i=1;i<ls;i++){
		p[i]=0; min[i]=1000000;
		for(j=0;j<l[i];j++){
			mn=0;
			for(k=0;k<l[i];k++){
				t=next[i][(k+j)%l[i]];
				if (mn<k+min[t]) mn=k+min[t];
			}
			if (mn<min[i]) { min[i]=mn; p[i]=j;}
		}
	}
	sp=0;
	cout << min[ls-1] << '\n';
	gen(ls-1);
	s[sp]=0;
	cout << s << '\n'; 
	return 0;
}